#include "histogram.h"

std::vector<size_t> make_histogram(std::vector<double> numbers, size_t bin_count)
{
    double max;
    double min;
    std::vector<size_t> bins;
    bins.resize(bin_count);
    find_minmax(numbers, min, max);
    double bin_size = (max - min) / bin_count;
    for (size_t i = 0; i < numbers.size(); i++) {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++) {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (hi > numbers[i])) {
                bins[j]++;
                found = true;
            }
        }
        if (!found) {
            bins[bin_count - 1]++;
        }
    }
    return bins;
}


bool find_minmax(std::vector<double> numbers, double& min, double& max) {
    if(numbers.size()==0){
        return false;
    }
    min = numbers[0];
    max = numbers[0];

    for (double number : numbers) {
        if (min > number) {
            min = number;
        }
        if (max < number) {
            max = number;
        }
    }
    return true;
}
